{
 terminal emulation that receives and displays characters
 from another instance of this. Keys are sent to the other
 instance of mailterm

 C>mailterm localslot remoteslot remotename
 e.g. on this host (homer) type
      c>mailterm term1 term2 ned
      on the remote host (ned) type
      c>mailterm term2 term1 homer
      so homer will read mail from \mailslot\term1
      and write mail to \\ned\mailslot\term2
      ned will read mail from \mailslot\term2
      and write mail to \\homer\mailslot\term1

 Two instances of mailterm could be run in DOS boxes on the local host:
 In one DOS box type C>mailterm term1 term2
 in the other DOS box type C>mailterm term2 term1
}
uses Dos, Hl_mail, Crt ;
var
  ecode : integer ;
  note : string ;
  inkey : char ;
  outkey : char ;
  inmail : text ;
  outmail : text ;

Procedure CheckErr( ecode : integer ) ;
begin
  if (ecode=0) or (ecode=121) then
    Exit ;
  Writeln( ' ** DOS error ',ecode ) ;
  Halt ;
end ;

begin
  Writeln ;
{
 Create local mailslot device
}
  Assignmail( '',Paramstr(1),1,1,inmail ) ;
  CheckErr( IoResult ) ;
  Reset( inmail ) ;
  CheckErr( IoResult ) ;
  Writeln( ' ++ Reading mailslot <',textRec( inmail ).name,'>' ) ;
{
 Set up remote mailslot access
}
  Assignmail( Paramstr(3),Paramstr(2),1,1,outmail ) ;
  CheckErr( IoResult ) ;
  Rewrite( outmail ) ;
  CheckErr( IoResult ) ;
  Writeln( '    Writing mailslot <',textRec( outmail ).name,'>' ) ;
  inkey := #0 ;
  repeat
    if Keypressed then
      begin
        inkey := Readkey ;
        Write( outmail,inkey ) ;
      end ;
    Read( inmail,outkey ) ;
    ecode := Ioresult ;
    if Not( ecode=121 ) then { 121 is read time out error }
      begin
        CheckErr( ecode ) ;
        System.Write( outkey ) ;
      end ;
  until (inkey=#$1B) ;
{
 Wrap up mailslots
}
  Close( inmail ) ;
  Close( outmail ) ;
  CheckErr( Ioresult ) ;
end .