{
 Wait for records from MAILPUT without using a text device driver.
 called with command line parameters
 C>mailget localname remotename
 e.g. c>mailget mail1     receive in mailbox 'mail1' from anybody

 Note that under Win9x one remote message was sent for each installed
      network protocol so messages should have identifying numbers
      to avoid receiving duplicates.
}
uses Hl_mail, Crt ;

type
  PDataRec = ^TDataRec ;
  TDataRec = record { record for demo }
               number : integer ;
               count  : longint ;
               filename : string[12] ;
               running : boolean ;
             end ;
var
  myslot : TMailSlot ;
  ecode : integer ;
  lim  : word ;
  indx : integer ;
  msgsize : word ;
  mslot   : string ;
  msg  : TDataRec ;
  lastnum : integer ;

Procedure CheckErr( ecode : integer ) ;
begin
  if (ecode=0) or (ecode=121) then
    Exit ;
  Writeln( ' ** DOS error ',ecode ) ;
  Halt ;
end ;

begin
  with myslot do
    begin
      mslot := Slotname( '',Paramstr(1) ) ;
      Init( mslot,Sizeof( msg ) ) ;
      Writeln;
      Writeln( ' ++ Creating mailbox <',mslot,'> with handle ',handle ) ;
      Writeln( '    Waiting ... ' ) ;
      if Hi( handle )=0 then
        repeat
          ecode := Info ;
          lim := infodata.msgswaiting ;
          if ( lim<>0 ) then
            for indx := 1 to lim do
              begin
                ecode := Read( msg,msgsize,0 ) ;
                if ( ecode=0 ) and ( msgsize=Sizeof( msg ) ) and
                   ( msg.number<>lastnum ) then
                  begin
                    with msg do
                      begin
                        Writeln( number:4,' ',count:6,' ',
                                 filename:12,' ',running ) ;
                        lastnum := number ; { avoid duplicates }
                      end ;
                  end ;
              end ;
        until Keypressed
      else
        CheckErr( Lo( handle ) ) ;
      Done ;
    end ;
end .