{
 Send records to MAILGET without using a text device driver.
 Called with command line parameters. MailGet must be running
 to receive the mail, otherwise MAILPUT will abort.

 C>mailput localname remotename
 e.g. c>mailput mail1 homer    send to mailbox 'mail1' on host 'homer'
      c>mailput mail1          send to mailbox 'mail1' on this host
      c>mailput mail1 *        send to mailbox 'mail1' on all hosts

 Not that when sending to remote hosts, the operating system will
     send out one message using each of the installed network
     protocols. For a localhost mailbox, this isn't the case.
}
uses Hl_mail, Crt ;
type
  PDataRec = ^TDataRec ;
  TDataRec = record { record for demo, could be anything }
               number : integer ;
               count  : longint ;
               filename : string[12] ;
               running : boolean ;
             end ;
var
  ecode : integer ;
  indx : integer ;
  msg  : TDataRec ;
  there : string ;

Procedure CheckErr( ecode : integer ) ;
begin
  if (ecode=0) or (ecode=121) then
    Exit ;
  Writeln( ' ** DOS error ',ecode ) ;
  Halt ;
end ;

begin
  there := Slotname( Paramstr(2),Paramstr(1) ) ;
  Writeln ;
  Writeln( ' ++ Mailing record to <',there,'>' ) ;
  Fillchar( msg,Sizeof( msg ),0 ) ; { initialise msg }
  ecode := WriteMailSlot( there,msg,Sizeof( msg ),1 ) ;
  CheckErr( ecode ) ;
  msg.filename := 'DATAFILE.TXT' ;
  for indx := 1 to 100 do { loop for 100 test strings }
    with msg do
      begin
        number := indx ;
        running := TRUE ;
        count := indx*10 ;
        Gotoxy( 1,Wherey ) ;
        Write( ' -- Mailing record #',indx:3 ) ;
        ecode := WriteMailSlot( there,msg,Sizeof( msg ),1 ) ;
        CheckErr( ecode ) ;
        if KeyPressed then
          Break ;
      end ;
  msg.running := FALSE ;
  Inc( msg.number ) ;
  ecode := WriteMailSlot( there,msg,Sizeof( msg ),1 ) ;
  CheckErr( ecode ) ;
  Writeln(' ... done' ) ;
end .